;
; DRAW BIOS (GENERIC x86-standard vram system LIBRARY)
; simplized & programmed by M.yanagisawa(MoroboshiLUM)
; 

DRAWBIOS_DEBUG_ENABLE	= 0

IF DRAWBIOS_DEBUG_ENABLE
		.Model	Small,C		;; use Borland C++ Small model.
ENDIF
		.186
		JUMPS
		LOCALS

include drawbios.inc

TRUE	equ -1
FALSE	equ 0

;
; FONTX2 Exists segment
; 
AFONT_SEG	=	0DF00H
KFONT_SEG	=	0A000H
KFONT_SEG_UPPER	=	0000AH

IF DRAWBIOS_DEBUG_ENABLE

data	=	@data

;; VRAMʃTCY̎wB(ׂword) [IBM-PC/AT VGA]
VRAMXSIZE	=	(640 / 8)
VRAMYSIZE	=	480

VIDEO_SEG	= 0a000h

ELSE

data	=	SYSRAM
VIDEO_SEG	= 7000h

;; VRAMʃTCY̎wB(ׂword)
VRAMXSIZE	=	(640 / 8)
VRAMYSIZE	=	200

ENDIF

; ----------------------------------------------------------------------
; O[oϐ
;
IF DRAWBIOS_DEBUG_ENABLE
;;; Borland C++ {@IBM-PC/AT(VGA) ł̃fobOpB
		.data
ELSE
SYSRAM	SEGMENT	WORD PUBLIC 'ASMDATA'
		ASSUME	DS:SYSRAM
ENDIF
;; NbsOGA
DRAW_CLIP_SX		dw	?	; w(ׂăsNZP)
DRAW_CLIP_SY		dw	?	; x
DRAW_CLIP_EX		dw	?	; Ew
DRAW_CLIP_EY		dw	?	; Ex

;; `pϐB
LINEPATTERN	dw	?	; Cp^[
MASKPATTERN	dw	?	; }XNp^[ (offset address)

IFE DRAWBIOS_DEBUG_ENABLE
;;; Borland C++ {@IBM-PC/AT(VGA) ł̃fobOpB
SYSRAM	ENDS
ENDIF
; ---------------------------------------------------------------------

IF DRAWBIOS_DEBUG_ENABLE
		.code
ELSE
BIOS SEGMENT WORD PUBLIC 'ASMCODE'
ASSUME	CS:BIOS,DS:SYSRAM,ES:SYSRAM,SS:SYSRAM
ENDIF

;; rbg[hp
Shifttbl	db	10000000b
		db	01000000b
		db	00100000b
		db	00010000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000001b

; ---------------------------------------------------------------
; Draw bios entry
; AH = function number 
;
public DrawBiosInt
DrawBiosInt	proc	far

		sti			;; enable interrupt
		push	si
		push	ax		;; backup ax
		mov	al,ah		;; ax=function number
		xor	ah,ah
		shl	ax,1		;; load function pointer into si reg
		mov	si,ax		;;
		pop	ax
		cmp	ah,DRAW_GETIMAGE
		ja	_DrawBios_ILLEGALFUNC
		call	cs:Functions[si]
_DrawBios_ILLEGALFUNC:
		pop	si
		iret

DrawBiosInt	endp

Functions	label	word
		dw	offset InitSimpleDraw
		dw	offset SelectPattern
		dw	offset SetClipArea
		dw	offset PutPixel
		dw	offset DrawLine
		dw	offset DrawBox
		dw	offset FillArea
		dw	offset DrawPutImage
		dw	offset DrawPutKanji
		dw	offset DrawGetImage

IF DRAWBIOS_DEBUG_ENABLE	;; DEBUG͊O烊Nł悤ɂ

Public DrawGetImage
public DrawPutImage
public SetClipArea
public FillArea
public DrawBox
public DrawLine
public PutPixel
public SelectPattern
public InitSimpleDraw
public DrawPutKanji

ENDIF

;
; KAhXւ̕ϊ
; inparam  DX:AX
; outparam DX:AX
;
ConvRegularAddress	proc	near

		push	bx
		push	cx

		mov	cx,dx
		shl	cx,4
		mov	bx,dx			; bx <- 4bit
		mov	bl,bh
		shr	bl,4
		mov	bh,0
		add	cx,ax			; |C^32bit
		adc	bx,0			; bx:cx = bx:cx + 0000:ax
		mov	ax,cx
		and	ax,000fh		; ax=offset (0~15)
		shr	cx,4			; cx >> 4
		shl	bl,4			; bl << 4
		or	ch,bl			; ch <- bl | ch .. AX=segment
		mov	dx,cx			; dx <- cx

		pop	cx
		pop	bx

		ret

ConvRegularAddress	endp

InitSimpleDraw	proc C 	near
		local	@@seg,@@ofs:word

		push	si
		push	di
		push	ds
		push	es

		push	es
		pop	ds
		push	bx
		pop	si
		mov	ax,DATA
		mov	es,ax
		xor	ax,ax
		mov	es:DRAW_CLIP_SX,ax		;; SX,SY = 0,0
		mov	es:DRAW_CLIP_SY,ax
		not	ax
		mov	es:LINEPATTERN,ax	;; LINEPATTERN=$FFFF
		mov	ax,offset BLOCKPATTERN
		add	ax,8*10			;; 100%
		mov	es:MASKPATTERN,ax

		mov	ax,VRAMXSIZE
		shl	ax,3			; pixel = byte * 8
		dec	ax
		mov	es:DRAW_CLIP_EX,ax		; clip area init.
		mov	ax,VRAMYSIZE
		dec	ax
		mov	es:DRAW_CLIP_EY,ax

		pop	es
		pop	ds
		pop	di
		pop	si

		ret

InitSimpleDraw	endp

; ------------------------------------------
; yp^[̃Zbg
; 
; AL = Zx (0 ~ 10)
; ------------------------------------------
SelectPattern	proc  	near

		push	si
		push	ds

		push	ax
		mov	ax,DATA
		mov	ds,ax
		pop	ax

		xor	ah,ah
		cmp	ax,10
		jbe	@@SELPTN_OK
		mov	ax,10			; 100%ȏȂ100%ɂB
@@SELPTN_OK:	shl	ax,3
		add	ax,offset BLOCKPATTERN
		mov	MASKPATTERN,ax		; store maskpattern offset

		pop	ds
		pop	si

		ret

SelectPattern	endp

; --------------------------------------------------
; NbsOGÃZbgBE͕`͈͓łB
; Nbv͈͕͂KWhbgȏmۂ邱ƁB
; w肵ȂƃG[ŕԂ܂B
; ES:BX  \̂̈ʒu
; --------------------------------------------------
SetClipArea	proc  C	near
		local	@@sx,@@ex,@@tmp:word		;; 

		push	si
		push	di
		push	ds
		push	es	;; 

		push	es
		pop	ds
		push	bx
		pop	si
		mov	ax,DATA
		mov	es,ax

		mov	ax,CLIP_SX[si]
		mov	bx,CLIP_EX[si]
		cmp	ax,bx			;; sx < ex ?
		jb	@@CLIPAREA_XOK		
		xchg	ax,bx			;; sx <--> ex
@@CLIPAREA_XOK:	mov	@@tmp,ax		;; fix tmp -> @@tmp
		mov	ax,VRAMXSIZE		;; ex>(VRAMXSIZE * 8 -1) ?
		shl	ax,3
		dec	ax
		cmp	bx,ax
		ja	@@CLIPAREA_ILLEGALAREA	;; ERROR.
		mov	ax,@@tmp		;; fix tmp -> @@tmp 
		push	bx
		sub	bx,ax
		mov	ax,bx
		pop	bx
		cmp	ax,8			;; 8pixelȏł邱ƁB
		jbe	@@CLIPAREA_ILLEGALAREA	;; ERROR
		mov	ax,@@tmp		;; fix tmp -> @@tmp
		mov	@@sx,ax		;; backup sx	;; ۗB
		mov	@@ex,bx		;; backup ex

		mov	ax,CLIP_SY[si]
		mov	bx,CLIP_EY[si]
		cmp	ax,bx			;; sy < ey ?
		jb	@@CLIPAREA_YOK
		xchg	ax,bx			;; sy <--> ey
@@CLIPAREA_YOK:	mov	@@tmp,ax		;; fix tmp -> @@tmp
		mov	ax,VRAMYSIZE		;; ey>(VRAMYSIZE - 1) ?
		dec	ax
		cmp	bx,ax
		ja	@@CLIPAREA_ILLEGALAREA	;; ERROR.
		mov	ax,@@tmp		;; fix tmp -> @@tmp
		push	bx
		sub	bx,ax
		mov	ax,bx
		pop	bx
		cmp	ax,8
		jbe	@@CLIPAREA_ILLEGALAREA	;; ERROR.
		mov	ax,@@tmp		;; fix tmp -> @@tmp
		;; ŏIZbgB
		mov	es:DRAW_CLIP_SY,ax		;; SY <- sy
		mov	es:DRAW_CLIP_EY,bx		;; EY <- ey
		mov	ax,@@sx
		mov	es:DRAW_CLIP_SX,ax		;; SX <- sx
		mov	ax,@@ex
		mov	es:DRAW_CLIP_EX,ax		;; EX <- ex

		mov	ax,-1			;; TRUE
		jmp	short @@CLIPAREA_EXIT
@@CLIPAREA_ILLEGALAREA:
		xor	ax,ax			;; FALSE
@@CLIPAREA_EXIT:

		pop	es	;; fix.
		pop	ds
		pop	di
		pop	si

		ret

SetClipArea	endp


; ------------------------------------------------------------------
; `W`FbNBNbsO͈͓łƂ AX = 0ԂB
; inparam  BX = X , DX = Y
; outparam AX = 0 L, -1 
; ------------------------------------------------------------------
_IsRegalPoint	proc	near

		mov	ax,DRAW_CLIP_SX
		cmp	bx,ax			;; sx > x then error
		jb	@@_IsRegalPoint_illegal
		mov	ax,DRAW_CLIP_EX
		cmp	bx,ax			;; ex < x then error
		ja	@@_IsRegalPoint_illegal

		mov	ax,DRAW_CLIP_SY
		cmp	dx,ax
		jb	@@_IsRegalPoint_illegal	;; sy > y then error
		mov	ax,DRAW_CLIP_EY
		cmp	dx,ax			;; ey < y then error
		ja	@@_IsRegalPoint_illegal

		xor	ax,ax

		ret

@@_IsRegalPoint_illegal:
		mov	ax,-1
		ret

_IsRegalPoint	endp

;; ******************************************************* W`FbN}N
;; wŴ͈͓Ƃ NO-Carry 
_CheckXPoint	proc	near

		cmp	ax,DRAW_CLIP_SX			;; sx > x then error
		jb	@@a
		cmp	ax,DRAW_CLIP_EX			;; ex < x then error
		ja	@@a
		clc
		jmp	short @@b
@@a:
		stc
@@b:
		ret

_CheckXPoint	endp

;; xŴ͈͓Ƃ NO-Carry 
_CheckYPoint	macro	REG
		local	@@a,@@b

		cmp	REG,DRAW_CLIP_SY			;; sy > y then error
		jb	@@a
		cmp	REG,DRAW_CLIP_EY			;; ey < y then error
		ja	@@a
		clc
		jmp	short @@b
@@a:
		stc
@@b:
		endm

;; ******************************************************* W`FbN}N

; -----------------------------------------------------------------------
; _̕`
; `搬ɂ͂`wɂOȊOԂ܂B
;
; AL    ݃y[W( 0: , 1 : wi)
; ## CjVɔwiƎbufferw肵ĂȂƂ͖܂
; BX    wW
; DX    xW
; CH    yTCY  0 ` 2
; CL    y[h  _WRITEMODE_RPL,_WRITEMODE_OR,_WRITEMODE_AND,_WRITEMODE_XOR
; ----------------------------------------------------------------------
PutPixel	proc	near

		push	cx
		push	dx
		push	si
		push	di
		push	ds

		push	ax
		and	ch,3				;; TCY}XN
		cmp	ch,3
		cmc
		sbb	ch,0				;; 3̂Ƃ2ɒB
		and	cl,3				;; [h}XN
		mov	ax,DATA
		mov	ds,ax				;; ftHgZOgZbg
		call	_IsRegalPoint			;; `L_H
		or	ax,ax
		pop	ax
		jnz	@@PutPixel_IllegalPoint
		call	PutPixelLocal		;; [JR[hĂԁB
		xor	ax,ax			;; B
@@PutPixel_IllegalPoint:
		not	ax
		pop	ds
		pop	di
		pop	si
		pop	dx
		pop	cx

		ret

PutPixel	endp


; --------------------------------------------------------------
; ۂɓ_łR[hiTCYPj
; BX = X, DX = Y, MODE  = CX
; --------------------------------------------------------------
_PutPixel1	proc C	near
		local	@@x,@@y,@@mode:word

		push	es

		mov	@@x,bx
		mov	@@y,dx
		mov	ch,al
		mov	@@mode,cx

		call	_IsRegalPoint		;; Nbv͈͓H
		or	ax,ax
		jnz	@@_PutPixel1_Exit

		xor	di,di			;; base address clear
		mov	ax,@@y
		mov	dx,VRAMXSIZE
		mul	dx			;; ax=y * VRAMXSIZE(byte)
		mov	dx,@@x
		shr	dx,3
		add	ax,dx			;; ax=y + x div 8
		add	di,ax			;; di=write offset address
		mov	bx,@@x
		and	bx,7			;; bit point
		mov	al,cs:shifttbl[bx]	;; al=maskbit
		xor	dx,dx
		mov	dl,al			;; dx=mask
		mov	ax,@@y
		mov	bx,@@mode
		call	_PutPixel_SubDraw	;; Ps`
@@_PutPixel1_Exit:

		pop	es


		ret


_PutPixel1	endp


; --------------------------------------------------------------
; ۂɓ_łR[hiTCYQj
; BX = X, DX = Y, MODE  = CX
; --------------------------------------------------------------
_PutPixel2	proc C	near
		local	@@x,@@y,@@mode,@@RowDrawPattern:word

		push	es

		mov	@@x,bx
		mov	@@y,dx
		mov	ch,al
		mov	@@mode,cx
		mov	cx,dx
		xor	dx,dx			;; `p^[NA
		inc	bx
		mov	ax,bx
		call	_CheckXPoint		;; (X+1,?)̓Nbv͈͓H
		rcr	dl,1			;; G[Ȃ1bit
		dec	bx
		mov	ax,bx
		call	_CheckXPoint		;; (X,?)̓Nbv͈͓H
		rcr	dl,1			;; G[Ȃ1bit
		not	dx			;; rbg𔽓]
		and	dx,0c0h			;; }XN
		or	dl,dl
		jz	@@_PutPixel2_Exit	;; `p^[ = 00 ȂEoB
;; Nbv}XN̍쐬
;; EŃ}XN̂ŁA̍sɂ܂悤ȏꍇłA̍s̃rbg
;; OFF̂Ŗ͏o܂B
		mov	cx,@@x			
		and	cx,7
		ror	dx,cl

		mov	@@RowDrawPattern,dx	;; `p^[}XNi[
;; `B
@@_PutPixel2_DRAW:
		;; 
		xor	di,di
		mov	ax,@@y
		mov	dx,VRAMXSIZE
		mul	dx			;; ax=y * VRAMXSIZE(byte)
		mov	dx,@@x
		shr	dx,3
		add	ax,dx			;; ax=y + x div 8
		add	di,ax			;; di=write offset address
		;; ES:DIAhX͏Ɍ (First ROW)
		;; xɂ܂m͎gp㏭Ȃ̂ŁB
		mov	ax,@@y
		mov	dx,@@RowDrawPattern	;; NbsOl}XN
		mov	bx,@@mode		;; `惂[h
		push	ax
		push	bx
		push	dx
		call	_PutPixel_SubDraw	;; Ps`
		pop	dx
		pop	bx
		pop	ax
		inc	ax			;; Y++;
		add	di,VRAMXSIZE		;; ̍s̃AhX
		call	_PutPixel_SubDraw	;; Qsڂ`

@@_PutPixel2_Exit:
		pop	es

		ret

_PutPixel2	endp


; --------------------------------------------------------------
; ۂɓ_łR[hiTCYSj
; BX = X, DX = Y, MODE  = CX
; --------------------------------------------------------------
_PutPixel4	proc C	near
		local	@@x,@@y,@@mode,@@RowDrawPattern1,@@RowDrawPattern2,@@modefiedx:word

		push	es

		mov	@@x,bx
		mov	@@y,dx
		mov	ch,al
		mov	@@mode,cx
		mov	cx,dx
		xor	dx,dx			;; `p^[NA
		inc	bx
		mov	ax,bx
		call	_CheckXPoint		;; (X+1,?)̓Nbv͈͓H
		rcr	dl,1			;; G[Ȃ1bit
		dec	bx
		mov	ax,bx
		call	_CheckXPoint		;; (X,?)̓Nbv͈͓H
		rcr	dl,1			;; G[Ȃ1bit
		not	dx			;; rbg𔽓]
		and	dx,0c0h			;; }XN 11000000b
;; Nbv}XNP̍쐬
;; `p^[Ṕ@QhbĝƂB
		mov	cx,@@x			
		sub	cx,1			;;x=x-1(dec׸ނȂ)
		adc	cx,0			;;if x<0 then x=(x-1)+1 (^^)
		mov	@@modefiedx,cx		;;{̊_i[
		cmp	cx,@@x
		jz	@@_PutPixel4_noshift
		shr	dx,1
@@_PutPixel4_noshift:
		and	cx,7
		ror	dx,cl
		mov	@@RowDrawPattern1,dx	;; `p^[P}XNi[
		xor	dx,dx			;; `p^[Q}XNNA
		mov	cx,4			;; ʏ탋[v񐔂Zbg
		mov	bx,@@x
		cmp	bx,1			;; bx < 1 ̂Ƃ Carry = ON
		lahf
		sbb	cx,0			;; if bx < 1 then cx = 3 !!!!!
		sahf
		rcr	dl,1			;; if bx < 1 then always mask(bit3)
		mov	ax,bx
		add	ax,2			;; (x-1)vẐ x-1,x,x+1,x+2
; `p^[Q́@ShbĝƂB_ɒӁI
@@_PutPixel4_makemaskloop:
		call	_CheckXPoint
		rcr	dl,1
		dec	ax
		loop	@@_PutPixel4_makemaskloop
		mov	cx,@@modefiedx
		and	cx,7
		not	dx			;; rbg𔽓]
		and	dx,0f0h			;; }XN
		ror	dx,cl			;; rbgVtg
		mov	@@RowDrawPattern2,dx	;; `p^[Q}XNi[
;; `B
		;; 
		xor	di,di			;; VRAM address BASE
		mov	ax,@@y
		cmp	ax,1			;;
		cmc				;; L[]
		sbb	ax,0			;; if ax > 0 then ax--;
		mov	dx,VRAMXSIZE
		mul	dx			;; ax=y * VRAMXSIZE(byte)
		mov	dx,@@modefiedx
		shr	dx,3
		add	ax,dx			;; ax=y + x div 8
		add	di,ax			;; di=write offset address
		;; ES:DIAhX͏Ɍ (First ROW)
		;; xɂ܂m͎gp㏭Ȃ̂ŁB
		mov	bx,@@mode		;; `惂[h
		mov	ax,@@y
		cmp	ax,0
		jz	@@_PutPixel4_clip	;; ax -1sڂȂ΂B
		mov	dx,@@RowDrawPattern1	;; NbsOl}XN
		dec	ax			;; y--;   !!!
		push	ax
		push	bx
		call	_PutPixel_SubDraw	;; Ps`
		pop	bx
		pop	ax
		inc	ax			;; Y++;
		add	di,VRAMXSIZE		;; ̍s̃AhX
@@_PutPixel4_clip:
		mov	dx,@@RowDrawPattern2	;; 1NbsOl}XN
		push	ax
		push	bx
		push	dx
		call	_PutPixel_SubDraw	;; Qsڂ`
		pop	dx
		pop	bx
		pop	ax
		inc	ax
		push	ax
		push	bx
		add	di,VRAMXSIZE		;; ̍s̃AhX
		call	_PutPixel_SubDraw	;; Rsڂ`
		pop	bx
		pop	ax
		inc	ax
		mov	dx,@@RowDrawPattern1
		add	di,VRAMXSIZE		;; ̍s̃AhX
		call	_PutPixel_SubDraw	;; Ssڂ`

@@_PutPixel4_Exit:
		pop	es

		ret

_PutPixel4	endp


; *******************************************************************************
; [Jbitput(1~9bit܂ł͐ɓ삷͂
; 3oCgׂ͍lOȂ̂10rbgȏ͕s
; DI     ރItZbgAhX
; AX     xWl
; DX	 `p^[}XN
; BL	 [h
; BH     ݃y[W
; WX^ES,DSȊO͔j󂳂܂B
; *******************************************************************************
_PutPixel_SubDraw	proc C	near
		local	@@patmask,@@page:word

		_CheckYPoint	ax		;; (?,Y)̓Nbv͈͂H
		jc	@@_PutPixelSubDraw_Exit	;; ̍s̕`
		mov	@@patmask,dx		;; `}XNۑ
		mov	@@page,bx
		push	bx			;; Modepush
		mov	cx,dx			;; cx=`}XN
		mov	bx,ax			;; YW
		and	bx,7
		add	bx,MASKPATTERN
		mov	ah,cs:[bx]		;; ah=maskpattern
		mov	al,ah			;; ax=maskpatterni16bit֊g)
		and	ax,cx			;; ax=ax & _RowDrawPattern(ۂ̂)
		mov	dx,ax

		;; cx=mask , dx=write data(bit)	;; ۑB

		pop	bx			;; BL=MODE,BH=WRITE PAGE
		mov	ax,VIDEO_SEG		;; for VGA mode
		mov	es,ax
		mov	ax,es:[di]		;; AX=VRAMf[^
@@_PutPixcelSubDraw_GotVRAM:
;; ============================================================== Iǂݍ
		mov	bx,@@page
		cmp	bl,_WRITEMODE_RPL
		jnz	@@_PutPixelSubDraw_next1
		;; ***** REPLACE *****
		mov	bx,cx
		not	bx			;; }XN𔽓]
		and	ax,bx			;; YrbgNA
		or	ax,dx			;; Cgf[^OR
		jmp	short @@_PutPixelSubDraw_write
@@_PutPixelSubDraw_next1:
		cmp	bl,_WRITEMODE_OR
		jnz	@@_PutPixelSubDraw_next2
		;; ***** OR *****
		or	ax,dx			;; Yrbgor
		jmp	short @@_PutPixelSubDraw_write
@@_PutPixelSubDraw_next2:
		cmp	bl,_WRITEMODE_AND
		jnz	@@_PutPixelSubDraw_next3
		;; ***** AND ******
		mov	bx,cx
		not	bx			;; }XN]
		or	bx,dx			;; ݃f[^Ń}XN
		and	ax,bx			;; YrbgAND
		jmp	short @@_PutPixelSubDraw_write
@@_PutPixelSubDraw_next3:
		;; ***** XOR *****
		xor	ax,dx			;; YrbgXOR ̃rbg0Ƃs
;;;		jmp	short @@_PutPixel2_write
;; ===================================================== f[^̔f
@@_PutPixelSubDraw_write:
		push	VIDEO_SEG			;; push	VRAM segment.
		pop	es
		cmp	di,(VRAMXSIZE * VRAMYSIZE)-1
		jb	@@_PutPixelSubDraw_wordwrite
		mov	es:[di],al
		jmp	@@_PutPixelSubDraw_Exit
@@_PutPixelSubDraw_wordwrite:
		mov	es:[di],ax
;; ======================================================================
@@_PutPixelSubDraw_Exit:	;; ̍s̕`

		ret

_PutPixel_SubDraw	endp

_PutPixel_Brush	label	word
		dw	offset	_PutPixel1
		dw	offset	_PutPixel2
		dw	offset	_PutPixel4
		dw	offset	_PutPixel4

;
; [JputpixcelBWX^R[
; WX^ۑ͓KxɁB
;
; AL=PAGE,BX=X,DX=Y,SIZE=CH,MODE=CL
; DS <-- SYSRAM0ł邱ƁB
; 
PutPixelLocal	proc 	near

		push	cx
		xchg	ch,cl
		xor	ch,ch
		mov	di,cx			;; TCY[h
		and	di,3			;; ꉞϽ 
		shl	di,1			;; ItZbgZbgB
		pop	cx
		xor	ch,ch			;; [hcxցB
		; AL=WRITE PAGE,BX = X, DX = Y, MODE  = CX
		call	CS:_PutPixel_Brush[di]	;; ݃[`R[

		ret

PutPixelLocal	endp

;
; `p[J_ŃR[h(PASCALR[)
;
pset	proc PASCAL near
	ARG  @@pensizemode,@@style:word

	push	di
	push	cx
	push	bx
	push	dx
	mov	cl,byte ptr @@pensizemode.1
	and	cl,0f0h
	shr	cl,4
	shr	ax,cl		; stepcnt = ys div pensize
	and	ax,0fh		; stepcnt = stepcnt and 0fh
	mov	cl,al
	mov	ax,8000h
	shr	ax,cl		; 
	and	ax,@@style	; bitcheck
	jz	@@pset_noset
	mov	bx,si
	mov	dx,di
	mov	cx,@@pensizemode  ;; ah=size&mode, al=writepage
	mov	al,cl
	mov	cl,ch
	and	ch,0fh
	shr	cl,4
	xchg	ch,cl		;; @@myan debug 5/12
	call	PutPixelLocal	;; _łB
@@pset_noset:
	pop	dx
	pop	bx
	pop	cx
	pop	di

	ret

pset	endp

;
; ES:DIŎw肳Ă DRAWLINE_PACS \̂̓e
; Nbv DX:AX Ŏw肵Ă\̂ɏ߂B
; A͏ BL=0 ̂Ƃ WȊO ̒l߂ȂB
; BH=0̂ƂYWւ܂B
;
; inparam 
;   es:di   source
;   dx:ax   destination
;   bl      execution requirement
;   bh      swap y point
;
ClipPoints	proc C	near
		local	@@sx,@@ex,@@sy,@@ey,@@inparam:word,@@dest:dword

		push	bx
		push	si
		push	di
		push	ds
		push	es

		mov	word ptr @@inparam,bx
		mov	word ptr @@dest,ax
		mov	word ptr @@dest.2,dx
;; ȂŌvZ
;; n_I_̐ݒ
		mov	ax,es:DLINE_X1[di]
		mov	bx,es:DLINE_X2[di]
		mov	cx,es:DLINE_Y1[di]
		mov	dx,es:DLINE_Y2[di]
		cmp	ax,bx			;; sx < ex ?
		jb	@@DLINE_XPARAMOK		
		xchg	ax,bx			;; sx <--> ex
		xchg	cx,dx			;; sy <--> ey
@@DLINE_XPARAMOK:
		mov	@@sx,ax		;; backup sx
		mov	@@ex,bx		;; backup ex
		mov	@@sy,cx		;; backup sy
		mov	@@ey,dx		;; backup ey

;; -------------------------------------------------
;; Clipping NbsOW͈͓ɂ
;; -------------------------------------------------
		mov	bx,DRAW_CLIP_EX
		mov	ax,@@sx
		cmp	ax,bx			;; _sx > ex ?
		jbe	@@sx_ok
		mov	ax,bx			;; _sx = ex
@@sx_ok:	mov	@@sx,ax			;; store _sx
		mov	ax,@@ex
		cmp	ax,bx			;; _ex > ex
		jbe	@@ex_ok
		mov	ax,bx			;; _ex = ex
@@ex_ok:	mov	@@ex,ax			;; store _ex
		mov	bx,DRAW_CLIP_EY
		mov	ax,@@sy
		cmp	ax,bx			;; _sy > ey ?
		jbe	@@sy_ok
		mov	ax,bx			;; _sy = ey
@@sy_ok:	mov	@@sy,ax
		mov	ax,@@ey
		cmp	ax,bx			;; _ey > ey ?
		jbe	@@ey_ok
		mov	ax,bx			;; _ey = ey
@@ey_ok:	mov	@@ey,ax
;;; ------------------------------------------------------
;;; JnX_د
		mov	bx,DRAW_CLIP_SX
		mov	ax,@@sx
		cmp	ax,bx			;; _sx < sx ?
		jae	@@sx_ok_sx
		mov	ax,bx			;; _sx = sx
@@sx_ok_sx:	mov	@@sx,ax			;; store _sx
		mov	ax,@@ex
		cmp	ax,bx			;; _ex > sx
		jae	@@ex_ok_sx
		mov	ax,bx			;; _ex = sx
@@ex_ok_sx:	mov	@@ex,ax			;; store _ex
;;; ------------------------------------------------------
;;; JnY_د
		mov	bx,DRAW_CLIP_SY
		mov	ax,@@sy
		cmp	ax,bx			;; _sy > sy ?
		jae	@@sy_ok_sy
		mov	ax,bx			;; _sy = sy
@@sy_ok_sy:	mov	@@sy,ax
		mov	ax,@@ey
		cmp	ax,bx			;; _ey > sy ?
		jae	@@ey_ok_sy
		mov	ax,bx			;; _ey = sy
@@ey_ok_sy:	mov	@@ey,ax
;;; ------------------------------------------------------
		mov	si,word ptr @@dest
		mov	ds,word ptr @@dest.2
		mov	ax,@@sx
		mov	DLINE_X1[si],ax
		mov	ax,@@ex
		mov	DLINE_X2[si],ax
		mov	ax,@@sy
		mov	dx,@@ey
		mov	bx,@@inparam
		or	bh,bh			;; check y point param?
		jnz	@@noexec_swapy
		cmp	ax,dx
		jbe	@@noexec_swapy
		xchg	ax,dx			;; sy <-> ey
@@noexec_swapy:
		mov	DLINE_Y1[si],ax
		mov	DLINE_Y2[si],dx

		or	bl,bl			;; copy mode,style,size ?
		jz	@@nomodewrite
		cld
		add	di,DLINE_MODE
		add	si,DLINE_MODE
		xchg	si,di
		mov	ax,es
		push	ds
		pop	es
		mov	ds,ax	
		movsw	;mode
		movsw	;size
		movsw	;style

@@nomodewrite:
		pop	es
		pop	ds
		pop	di
		pop	si
		pop	bx

		ret

ClipPoints	endp

; ------------------------------------------------------------
; ̕`
; AL     ݃y[W
; ES:BX  \̂̈ʒu
; ------------------------------------------------------------
DrawLine	proc C	near
		local	@@dest:DRAWLINE_PACS

		push	si
		push	di
		push	ds
		push	es

		push	bx
		pop	di
		mov	ax,DATA
		mov	ds,ax

		lea	ax,@@dest
		push	ss
		pop	dx
		mov	bx,-1
		call	ClipPoints

		mov	al,byte ptr @@dest.DLINE_MODE
		and	al,0fh
		mov	ah,byte ptr @@dest.DLINE_SIZE
		shl	ah,4
		or	ah,al
		mov	bx,@@dest.DLINE_STYLE
		mov	si,@@dest.DLINE_X1
		mov	di,@@dest.DLINE_Y1
		mov	cx,@@dest.DLINE_X2
		mov	dx,@@dest.DLINE_Y2
		call	DrawLineLocal

		pop	es
		pop	ds
		pop	di
		pop	si

		ret


DrawLine	endp


; ------------------------------------------------------------------------
; C`惋[`
; si=x1,di=y1,cx=x2,dx=y2,bx=style,al=writepage ,ah=mode & pensize
; ah ʂSrbg݃[hAʂSrbgyTCY
; yX^CΉ
; ------------------------------------------------------------------------
DrawLineLocal proc C near
	local @@ddx:word,@@d2x:word,@@ddy:word,@@d2y:word,@@ssy:word
	local @@pensizemode:word,@@style:word

	push	ds
	mov	@@style,bx
	mov	@@pensizemode,ax	;; [hAyTCYҔ
;; n_EI_̏C
	cmp	si,cx
	jbe	@@DrawLineLocal_NormalPoint
	; n_̕傫ƂB
	xchg	si,cx
	xchg	di,dx
@@DrawLineLocal_NormalPoint:
;; 
	push	cx
	sub	cx,si
	mov	@@ddx,cx		; ddx=xe-xs
	pop	cx
	mov	ax,@@ddx
	sal	ax,1		; d2x=ddx*2
	mov	@@d2x,ax

	push	dx
	mov	@@ssy,1		; ݒ
	sub	dx,di		; ye-ys
	jg	@@DrawLineLocal_PointOK
	jz	@@DrawLineLocal_Zero
	; l𐳒lɕϊ
	neg	dx
	mov	@@ssy,-1
	jmp	short @@DrawLineLocal_PointOK
@@DrawLineLocal_Zero:
	mov	@@ssy,0
@@DrawLineLocal_PointOK:
	mov	@@ddy,dx
	sal	dx,1
	mov	@@d2y,dx
	pop	dx

; ***********************************************
; `̃C[`
; T^IBresenhamASYłB
; ***********************************************

	mov	ax,@@ddy
	or	ax,@@ddx
	jnz	@@DrawLineLocal_Draw
;; Phbĝ݂̂ƂB
	mov	ax,di
	push	@@pensizemode
	push	@@style
	call	pset
	jmp	@@DrawLineLocal_drawexit
@@DrawLineLocal_Draw:
	mov	ax,@@ddy
	cmp	ax,@@ddx
	jle	@@DrawLineLocal_MinusDraw
	mov	bx,@@d2x
	sub	bx,@@ddy		;sub d2x,ddy
@@DrawLineLocal_PlusLoop1:
	;; di = ys
	mov	ax,di		; di=ys !
	push	@@pensizemode
	push	@@style
	call	pset
	mov	ax,@@d2y
@@DrawLinelocal_PlusLoop2:
	cmp	bx,0
	jle	@@DrawLineLocal_skipexit1
	sub	bx,ax
	inc	si
	jmp	short @@DrawLinelocal_PlusLoop2
@@DrawLineLocal_skipexit1:
	add	bx,@@d2x
	add	di,@@ssy
	cmp	dx,di
	jnz	short @@DrawLineLocal_PlusLoop1
;
; XWiXSTxȏj

	mov	ax,di		; di=ys !
	push	@@pensizemode
	push	@@style
	call	pset		;; Ō̏݁B
	jmp	short @@DrawLineLocal_DrawExit
;; 
@@DrawLineLocal_MinusDraw:
	mov	bx,@@d2y
	sub	bx,@@ddx		;ed=sub d2y,ddx
@@DrawLineLocal_MinusDrawLoop1:

; XWiXSTxȉj

	mov	ax,si		; si=xs !
	push	@@pensizemode
	push	@@style
	call	pset
	mov	ax,@@d2x
@@DrawLineLocal_MinusDrawLoop2:
	cmp	bx,0
	jng	@@DrawLineLocal_MinusDrawLoop2exit
	sub	bx,ax
	add	di,@@ssy
	jmp	short @@DrawLineLocal_MinusDrawLoop2
@@DrawLineLocal_MinusDrawLoop2exit:
	add	bx,@@d2y
	inc	si
	cmp	si,cx
	jng	@@DrawLineLocal_MinusDrawLoop1
@@DrawLineLocal_drawexit:

	pop ds

	ret

DrawLineLocal endp


; ----------------------------------------------------
; `B
; AL       ݃y[W
; ES:BX    \̂̃AhX
; ----------------------------------------------------
DrawBox	proc	C	near
		local	@@dest:DRAWLINE_PACS

		push	si
		push	di
		push	ds
		push	es

		push	bx
		pop	di
		mov	ax,DATA
		mov	ds,ax

		lea	ax,@@dest
		push	ss
		pop	dx
		;; mode,style,size copy enable,enable check y param
		mov	bx,00ffh
		call	ClipPoints

		mov	al,byte ptr @@dest.DLINE_MODE
		and	al,0fh
		mov	ah,byte ptr @@dest.DLINE_SIZE
		or	ah,al
		mov	bx,@@dest.DLINE_STYLE

		mov	si,@@dest.DLINE_X1
		mov	di,@@dest.DLINE_Y1
		mov	cx,@@dest.DLINE_X2
		mov	dx,di

		push	si	; x1
		push	cx	; x2

		; (X1,Y1) - (X2,Y1)
		push	ax
		push	bx
		call	DrawLineLocal
		pop	bx
		pop	ax

		pop	cx
		pop	si

		; (X1,Y2) - (X2,Y2)
		mov	di,@@dest.DLINE_Y2
		mov	dx,di
		cmp	dx,@@dest.DLINE_Y1
		jz	@@DrawBox_nodrawx
		push	ax
		push	bx
		call	DrawLineLocal
		pop	bx
		pop	ax
@@DrawBox_nodrawx:

		; (X1,Y1) - (X1,Y2)
		mov	si,@@dest.DLINE_X1
		mov	di,@@dest.DLINE_Y1
		mov	cx,si		;;dest.DLINE_X1
		mov	dx,@@dest.DLINE_Y2

		push	ax
		mov	ax,dx
		sub	ax,di
;;		cmp	ax,2
		cmp	ax,1		;; 
		pop	ax
		jbe	@@DrawBox_nodraw
		dec	dx		;; dec y2
		inc	di		;; inc y1

		push	di
		push	dx

		cmp	si,@@dest.DLINE_X2	;; 98/08/20
		jz	@@DrawBox_nodrawy	;; 98/08/20
		push	ax
		push	bx
		call	DrawLineLocal
		pop	bx
		pop	ax
@@DrawBox_nodrawy:				;; 98/08/20

		; (X2,Y1) - (X2,Y2)
		pop	dx
		pop	di
		mov	si,@@dest.DLINE_X2
		mov	cx,si
		call	DrawLineLocal
@@DrawBox_nodraw:

		pop	es
		pop	ds
		pop	di
		pop	si

		ret


DrawBox	endp

; ---------------------------------------------------
; }XNrbg̐([J[`)
; inparam
;    BX    ]JnwW
;    DX    ]IwW
; outparam
;    AH    [}XN
;    AL    E[}XN
; ---------------------------------------------------
TransferLine_MakeMask	proc	near

		push	cx

		mov	cx,bx	;; cx=sx
		and	cx,7
		xor	al,al
		stc		;; carry |  ax(0)
		rcr	al,cl	;;   ===> carry bit rotation.
		dec	al	;; [}XNitj
		not	al	;; ]
		mov	ah,al	;; ah <- left mask
		xor	al,al
		mov	cx,dx
		and	cx,7
		inc	cx
		stc		;; carry(data)
		rcr	al,cl	;;
		dec	al	;; E[}XN
				;; al <- right mask
		pop	cx

		ret

TransferLine_MakeMask	endp

; -------------------------------------------------------------------------------
; Ps̃tBByZx𔽉f܂B
; BX        tBJnwW
; DX        tBIwW
; CX        tB@@xW
; AL(0~3)   hԂ_(RPL,OR,AND,XOR)
; AL(4~7)   hԂyZx
; Ӂ@@NbvGA͍l܂iĂяoŃNbv邱Ɓj
; -------------------------------------------------------------------------------
FillLine_Sub	proc C	near
		local @@buf,@@ofs,@@mask,@@count,@@y : word
		local @@tmp:byte,@@filldat:byte,@@fillmode:byte

		push	si
		push	di
		push	ds
		push	es

		mov	@@fillmode,al
		and	@@fillmode,byte ptr 0fh	;; !!
		mov	@@y,cx
		push	bx
		xor	ah,ah
		and	al,0f0h
		shr	al,1			;; 8{̂1bitB
		add	ax,offset BLOCKPATTERN	;; ubNp^[ItZbg
		mov	bx,cx			;; YW
		and	bx,7			;; pattern mask offset 
		add	bx,ax			;; MASKPATTERN
		mov	al,cs:[bx]		;; al=maskpattern
		mov	@@filldat,al		;; fill data쐬
		pop	bx

		mov	ax,bx
		shr	ax,3	;; ax = start address
		mov	cx,dx
		shr	cx,3	;; cx = end address

;; -------- make address. tBItZbgAhXvZB
		push	ax
		push	dx
		xor	di,di	;; vram address
		add	di,ax	;; +x address
		mov	ax,@@y
		mov	dx,VRAMXSIZE
		mul	dx
		add	di,ax	;; +y
		mov	word ptr @@ofs,di	;; di͂Ȃɕۑ:-)
		pop	dx
		pop	ax
;; --------
		cmp	ax,cx
		jnz	@@FillLine_over1byte
;; -------------------------------------------------------
;; 1oCgȉ̓] ([̃}XNandĐj
;; -------------------------------------------------------
		call	TransferLine_MakeMask	;; cƂ}XN
		or	ah,al		;; }XN
		mov	@@tmp,ah	;; tmp=}XN
		mov	dl,@@filldat	;; s[h
		mov	al,@@filldat
@@FillLine_write:
		mov	ah,@@tmp
		push	VIDEO_SEG
		pop	es
		mov	dl,es:[di]
		mov	dh,dl
		and	dl,ah	;; ߍݕNA
		not	ah
		and	dh,ah	;; ް
		and	al,ah	;; ݃f[^
		mov	bl,@@fillmode
		cmp	bl,_WRITEMODE_RPL
		jz	@@FillLine_ByteSet	;; ̂܂܏B
		cmp	bl,_WRITEMODE_OR
		jnz	@@FillLine_ByteAnd
		or	al,dh	;;
		or	al,dl	;;
		jmp	@@FillLine_ByteSet
@@FillLine_ByteAnd:
		cmp	bl,_WRITEMODE_AND
		jnz	@@FillLine_ByteXor
		and	al,dh	;;
		jmp	@@FillLine_ByteSet
@@FillLine_ByteXor:
		xor	al,dh	;;
@@FillLine_ByteSet:
		or	al,dl	;;
		mov	es:[di],al
		jmp	@@FillLine_exit
;; ----------------------
;; IB
;; ----------------------
; --------------------------------------------------------------
; QoCgȏi[̃AhX͈قȂj̃R[h
; ]̈̏dȂlĂ܂(dȂl̂
; ʂ̃R[hg܂)
; --------------------------------------------------------------
@@FillLine_over1byte:
		sub	cx,ax
		dec	cx		;; cx=transfer bytes([ȊO)
		mov	@@count,cx
		call	TransferLine_MakeMask
		mov	dx,ax		;; }XNۑ
		mov	@@mask,ax
		mov	bx,cx
		inc	bx		;; {P̃AhXE[B
		push	VIDEO_SEG
		pop	es
		mov	ah,es:[di]
		mov	al,es:[di+bx]
	;; alɍ[AahɉE[̓]VRAMf[^̂ƂɓĂB
	;; dl,dhɂ͂ꂼΉ}XNB
		push	bx
		mov	bx,ax		;; ްҔ
		and	ax,dx		;; Lf[^݂̂𔲂o
		not	dx		;; ]}XNœ]f[^𔲂
		mov	cl,@@filldat
		mov	ch,cl
		and	cx,dx		;; B
		and	dx,bx		;; ް
;;;
		mov	bl,@@fillmode
		cmp	bl,_WRITEMODE_RPL
		jz	@@FillLine_WordSet	;; ̂܂܏B
		cmp	bl,_WRITEMODE_OR
		jnz	@@FillLine_WordAnd
		or	cx,dx		;;
		jmp	@@FillLine_WordSet
@@FillLine_WordAnd:
		cmp	bl,_WRITEMODE_AND
		jnz	@@FillLine_WordXor
		and	cx,dx	;;
		jmp	@@FillLine_WordSet
@@FillLine_WordXor:
		xor	cx,dx	;;
@@FillLine_WordSet:
		pop	bx
		or	ax,cx			;; f[^
	;; al,ahɏ݁B
		push	VIDEO_SEG
		pop	es
		mov	es:[di],ah
		mov	es:[di+bx],al
;; --------------------------------------------- ܂łŒ[̏IB
	;; {̓]B
		mov	cx,@@count		;; ](byte order)
		cmp	cx,0
		jz	@@FillLine_Exit
		push	di
		inc	di
		mov	si,di
		mov	ax,VIDEO_SEG	;; VGA VRAM.
		mov	es,ax		;; 
		mov	ds,ax		;; 
		mov	al,@@filldat
		mov	ah,al
		mov	dx,ax		;; dx = ax = filldata
		cld
		mov	bl,@@fillmode
		cmp	bl,_WRITEMODE_RPL
		jnz	@@FillLine_Or
;;; ---------
		push	cx
		shr	cx,1
		repe	stosw
		pop	cx
		test	cx,1
		jz	@@FillLine_next
		stosb
		jmp	@@FillLine_next
;;; ---------
@@FillLine_Or:
		cmp	bl,_WRITEMODE_OR
		jnz	@@FillLine_And
		push	cx
		shr	cx,1
@@FillLineOr_Loop:
		lodsw
		or	ax,dx
		stosw
		loop	@@FillLineOr_Loop
		pop	cx
		test	cx,1
		jz	@@FillLine_next
		lodsb
		or	al,dl
		stosb
		jmp	@@FillLine_next
;;; ---------
@@FillLine_And:
		cmp	bl,_WRITEMODE_AND
		jnz	@@FillLine_Xor
		push	cx
		shr	cx,1
@@FillLineAnd_Loop:
		lodsw
		and	ax,dx
		stosw
		loop	@@FillLineAnd_Loop
		pop	cx
		test	cx,1
		jz	@@FillLine_next
		lodsb
		and	al,dl
		stosb
		jmp	@@FillLine_next
;;; ---------
@@FillLine_Xor:
		push	cx
		shr	cx,1
@@FillLineXor_Loop:
		lodsw
		xor	ax,dx
		stosw
		loop	@@FillLineXor_Loop
		pop	cx
		test	cx,1
		jz	@@FillLine_next
		lodsb
		xor	al,dl
		stosb
@@FillLine_next:
		pop	di
@@FillLine_exit:
		pop	es
		pop	ds
		pop	di
		pop	si

		ret

FillLine_Sub	endp

; ------------------------------------------------------------------------------
; `̈tB
; w肳ꂽ̃f[^w̃yŖ߂܂B
; AL(0~3) ݘ_Ӱ
; AL(4~7) yZx(0`10)
; ES:BX   ]̈w肷\̂̈ʒu
; ------------------------------------------------------------------------------
FillArea	proc C	near
		local	@@pacs:FillArea_PACS,@@writemode:byte

		push	si
		push	di
		push	ds
		push	es

		push	bx
		pop	di
		mov	@@writemode,al	;; backup writemode 
		mov	ax,DATA
		mov	ds,ax
		;; mode,style,size copy disable,enable check y param
		xor	bx,bx
		push	ss
		pop	dx
		lea	ax,@@pacs	;; NbvWi[obt@
		call	ClipPoints	;; WNbv
;; @@pacsɃp[^͂B
		mov	bx,@@pacs.FillArea_SX
		mov	dx,@@pacs.FillArea_EX
		mov	cx,@@pacs.FillArea_SY
		mov	al,@@writemode
;; Zx̃`FbNB
		mov	ah,al		;; ah break.
		and	ah,0f0h
		cmp	ah,0a0h		;; intensity < 10 ?
		jbe	@@FillLine_intencityok
		mov	ah,0a0h		;; intensity max=10
@@FillLine_intencityok:
		and	al,0fh
		or	al,ah		;; 
@@FillArea_Loop:
		push	ax
		push	cx
		push	bx
		push	dx
		call	FillLine_Sub	;; 1s𖄂߂
		pop	dx
		pop	bx
		pop	cx
		pop	ax
		inc	cx
		cmp	cx,@@pacs.FillArea_EY	;; `̈扺[܂Ŏs
		jbe	@@FillArea_Loop

		pop	es
		pop	ds
		pop	di
		pop	si
		
		ret

FillArea	endp

; ----------------------------------------------------------------
; C[WPUT
; NbvWl܂BNbvWzꍇ́AI
; NbvEɕ`܂
;
;  ES:BX    󂯓np\̂̃AhX
;
; ----------------------------------------------------------------
PutImage_Engine	proc	near

	lodsb				;; ރf[^[h
	xchg	al,dl			;; Xchg AL <- f[^  DL <- f[^
	mov	dh,dl			;; DH <- f[^
	and	dh,bh			;; DH <- Vtgf[^NA
	and	al,ah			;; AL <- VtgȊÕf[^NA
	or	al,dh			;; 
	ror	al,cl			;; VtgZ

	ret

PutImage_Engine	endp

;
; C[WZGW
; ch=pe _ mask
;
PutImage_Set	proc near

	mov	dl,es:[di]		;; VtgŖ߂f[^ f[^
	rol 	dl,cl			;; f[^߂Čɂ܂ق悤ɂ
	or 	bl,bl			;; JE^[=0̂ƂB
	jz	@@PutImg_endstate_set
@@PutImg_looptrans_set:
	call	PutImage_Engine
	stosb				;; VRAMփXgA
	dec	bl			;; byteݒ
	jne 	@@PutImg_looptrans_set
;; [̏
@@PutImg_endstate_set:
	call	PutImage_Engine
	mov	ah,ch			;; }XNǂݍ
	mov	dl,es:[di]		;; f[^ǂݍ
	and	dl,ah
	not	ah
	and	al,ah
	or	al,dl			;; f[^Əf[^
	stosb				;; XgA

	ret

PutImage_SET	endp

PutImage_OR	proc	near

	mov	dl,0		;; OȐꍇA0Ōf[^ORƂΕςȂ
	or	bl,bl		;; JE^[=0̂ƂB
	jz	@@PutImg_endstate_or
@@PutImg_looptrans_or:
	call	PutImage_Engine
	or	es:[di],al	;; VRAMփXgA
	inc	di
	dec	bl		;; byteݒ
	jne	@@PutImg_looptrans_or
;; [̏
@@PutImg_endstate_or:
	call	PutImage_Engine
;;	mov	ah,ch		;; }XNǂݍ
;;	not	ah
;;	and	al,ah		;; f[^ȊO0ɂ(or̂)
	not	ch
	and	al,ch		;; f[^ȊO0ɂ(or̂)
	or	es:[di],al	;; VRAMփXgA

	ret

PutImage_OR	endp

PutImage_AND	proc	near


	mov	dl,0ffh			;; ANDȂ̂Ńtrbgł悢B
	or	bl,bl			;; JE^[=0̂ƂB
	jz	@@PutImg_endstate_and
@@PutImg_looptrans_and:
	call	PutImage_Engine
	and	es:[di],al		;; VRAMփXgA
	inc	di
	dec	bl			;; byteݒ
	jne	@@PutImg_looptrans_and
;; [̏
@@PutImg_endstate_and:
	call	PutImage_Engine
;;	mov	ah,ch			;; }XNǂݍ
;;	mov	dl,ah			;; ANDȂ̂ŁÂ܂܃}XN[h΂悢
;;	or	al,ah			;; ̂܂܃}XNor(f[^bitȊO1)
	or	al,ch			;; ̂܂܃}XNor(f[^bitȊO1)
	and	es:[di],al		;; XgA

	ret

PutImage_AND	endp

PutImage_XOR	proc	near

	mov	dl,0			;; XORȂ̂0ɂĂ(f[^ωh~
	or	bl,bl			;; JE^[=0̂ƂB
	jz	@@PutImg_endstate_xor
@@PutImg_looptrans_xor:
	call	PutImage_Engine
	xor	es:[di],al		;; VRAMփXgA
	inc	di
	dec	bl			;; byteݒ
	jne	@@PutImg_looptrans_xor
;; [ or PoCg̃p^[̂Ƃ̏
@@PutImg_endstate_xor:
	call	PutImage_Engine
;;	mov	ah,ch			;; }XNǂݍ
;;	not	ah
;;	and	al,ah			;; }XN̎c0Ȃ̂ŁÂ܂܂ok
	not	ch
	and	al,ch			;; }XN̎c0Ȃ̂ŁÂ܂܂ok
	xor	es:[di],al		;; VRAMփXgA

	ret

PutImage_XOR	endp

PutImage_sub	label	word
		dw	PutImage_SET
		dw	PutImage_AND		;; 
		dw	PutImage_OR		;; FUNCTIONAND/ORt
		dw	PutImage_XOR

;
; \ł̓}CiXW͍l܂.
;
DrawPutImage	proc C	near
		local	@@DispWidth,@@PictWidth,@@DispHeight,@@PictHeight:word
		local	@@sx,@@sy,@@ex,@@ey,@@dispst,@@transsiz,@@baseofs,@@func:word
		local	@@pe:byte
		local	@@src:dword,@@dest:dword

		push	si
		push	di
		push	ds
		push	es

		mov	ax,DATA		;; f[^ZOgݒB
		mov	ds,ax

		mov	ax,es:PutImg_x[bx]
		mov	@@sx,ax
		mov	ax,es:PutImg_y[bx]
		mov	@@sy,ax

		mov	ax,es:PutImg_ofs[bx]
		mov	word ptr @@src,ax
		mov	ax,es:PutImg_seg[bx]
		mov	word ptr @@src.2,ax

		push	bx
		mov	ax,es:PutImg_mode[bx]
		and	ax,3
		shl	ax,1
		mov	bx,ax
		mov	ax,cs:PutImage_sub[bx]	;;t@NV
		mov	@@func,ax
		pop	bx

		push	es
		push	VIDEO_SEG
		pop	dx
		xor	ax,ax
		pop	es
		mov	word ptr @@dest,ax
		mov	word ptr @@dest.2,dx

		mov	ax,es:PutImg_Height[bx]
		mov	@@PictHeight,ax		;; C[W
		or	ax,ax
		jz	@@PutImg_error		;; C[WG[(Oj
;;; AvP[VŃ`FbN
;;;		mov	dx,DRAW_CLIP_EY
;;;		sub	dx,DRAW_CLIP_SY
;;;		inc	dx			;; Nbv̈̍
;;;		cmp	ax,dx
;;;		ja	@@PutImg_error		;; Nbv̈荂C[W͋֎~

		;; o͍W̃`FbNiȄC)
		mov	ax,DRAW_CLIP_EX
		mov	dx,@@sx			;; dx = @@sx 
		cmp	dx,ax
		jbe	@@PutImage_sxhiok
		mov	dx,ax			;; őlzĂEX
@@PutImage_sxhiok:
		mov	ax,DRAW_CLIP_SX
		cmp	dx,ax
		jae	@@PutImage_sxlook
		mov	dx,ax			;; ŏlzĂSX
@@PutImage_sxlook:
;;; @@sy͍\ȂB
		mov	@@sx,dx			;; dx -> @@sx
		mov	cx,@@sy			;; cx=@@sy
		mov	@@dispst,0		;; C[W̕`X^[gʒu
		mov	ax,DRAW_CLIP_EY
		cmp	cx,ax
		jbe	@@PutImage_syok
		mov	cx,ax
@@PutImage_syok:
		mov	ax,DRAW_CLIP_SY
		cmp	cx,ax
		jae	@@PutImage_noimgstchg	;; SY艺ŕ\Ȃ疳C
		;; sy SYłƂimage startCB
		mov	dx,@@PictHeight
		add	dx,cx
		dec	dx			;; dx=[ yW
		cmp	dx,ax
		jae	@@PutImage_HeightChange	;; [ȂƂ́APC͌悤
		sub	ax,@@PictHeight
		inc	ax			;; \ʒu(PCĂ)
		jmp	short @@PutImage_SetPos
@@PutImage_HeightChange:
		mov	ax,cx
@@PutImage_SetPos:
;;;;;		mov	@@sy,ax			;; \ʒuC
		mov	dx,DRAW_CLIP_SY
		sub	dx,ax			;; dx=\JnItZbg
		mov	@@dispst,dx		;; 
		mov	dx,DRAW_CLIP_SY
		add	ax,@@PictHeight
		sub	ax,dx
		mov	@@PictHeight,ax		;; ۂɏލ
		mov	cx,dx			;; \JnʒuSYɂȂ
@@PutImage_noimgstchg:
		mov	@@sy,cx
		;; C[W̃Nbv
		mov	ax,es:PutImg_width[bx]
		mov	@@DispWidth,ax
		or	ax,ax
		jz	@@PutImg_error		;; C[WG[iOj
		dec	ax
		shr	ax,3
		inc	ax
		mov	@@PictWidth,ax		;; C[W(byte)
		jmp	short @@PutImg_ClipWidthHeight
@@PutImg_Error:
		mov	ax,-1
		jmp	@@PutImg_Exit
;; AvP[VŃ`FbN
;;;		mov	dx,DRAW_CLIP_EX
;;;		sub	dx,DRAW_CLIP_SX
;;;		inc	dx
;;;		cmp	ax,dx
;;;		ja	@@PutImg_error		;; C[WNbv̈傫Ƃ̓G[

;;
;;; o̓C[Wƍ̃Nbv
;; 
@@PutImg_ClipWidthHeight:
		mov	dx,@@DispWidth
		mov	ax,@@sx
		mov	si,ax
		add	ax,dx
		dec	ax			;; \Iʒu
		cmp	ax,DRAW_CLIP_EX			;; C[WI[NbvEz
		jbe	@@PutImg_Regalposx	;; CB
		mov	dx,DRAW_CLIP_EX			;; NbvW|\JnW{P
		sub	dx,si			;; dx += @@sx
		inc	dx
		mov	@@DispWidth,dx		;;XV
;;;
@@PutImg_Regalposx:
;;		push	dx			;; xmaxlɂC[W̍XV
		mov	ax,@@PictHeight
		add	ax,cx			;; cx = @@sy !!!!!
		cmp	ax,DRAW_CLIP_EY
		jbe	@@PutImg_HeightOK
		mov	ax,DRAW_CLIP_EY
		sub	ax,cx			;; 
		inc	ax
		mov	@@PictHeight,ax		;; PictHeight\E܂łɏC
@@PutImg_HeightOK:
		mov	ax,si			;; si=@@sx !!!!
		add	ax,@@DispWidth
		dec 	ax
		mov	@@ex,ax			;; ex = I|Cg
;;;
		push	ax
		shr	ax,3			;; 
		mov	dx,si			;; si = @@sx !!!
		shr	dx,3
		sub	ax,dx
		mov	@@transsiz,ax		;; ]B
;;
		pop	dx
		mov	bx,dx
		call	TransferLine_MakeMask	;;
		;; ah left  al right mask
		mov	@@pe,al			;; endmask.

		lds	si,@@src		;; ]
		mov	ax,@@dispst		;; ]̃x[Xx
		mov	dx,@@PictWidth		;; C[W̕ibyte)
		mul	dx
		add	si,ax			;; x[XB
		les	di,@@dest
		mov	ax,@@sy
		mov	dx,VRAMXSIZE
		mul	dx
		add	di,ax
		mov	@@baseofs,ax
		mov	ax,@@sx
		shr	ax,3
		add	@@baseofs,ax		;; zVRAM݃x[XItZbg
		add	di,ax			;; `AhX
;;  DS:SI , ES:DIB
;; ===================================================== xC[v
@@PutImg_Mainloop:
		push	di
		push	si
		mov	cx,@@sx
		and	cx,7			;; Vtg
		mov	ah,1
		shl	ah,cl
		dec	ah			;; AH=bit mask
 		mov	bl,byte ptr @@transsiz	;; ]f[^[h
		mov	bh,ah			;;
		not	bh			;; BH=AH]}XN
		cld
		mov	ch,@@pe
		call	@@func			;; ͂ߍ݊֐̃R[
		pop	si
		pop	di
		add	si,@@PictWidth		;; C[WItZbgXV
		mov	bx,@@baseofs		;; x[XItZbg
		mov	dx,@@transsiz		;; ύXoCg
		inc	dx
		mov	ax,VRAMXSIZE
		add	@@baseofs,ax		;; \x[XItZbgXV
		add	di,ax
		dec	@@PictHeight
		jnz	@@PutImg_MainLoop
		xor	ax,ax
;; ===================================================== xC[v
@@PutImg_Exit:
		pop	es
		pop	ds
		pop	di
		pop	si

		ret

DrawPutImage	endp

GetFont		proc C	near
		local	@@fontofs:WORD,@@min:WORD

		push	bx
		push	si
		push	ds

		test	ah,0
		jz	@@GetFont_ank

		mov	bx,ax		;; bx is fontcode

		mov	ax,KFONT_SEG
		mov	ds,ax
		cld
		mov	si,12h
		lodsb
		cbw
		mov	cx,ax
		shl	ax,2
		add	ax,12h
		mov	@@fontofs,ax
		xor	ax,ax
		xor	dx,dx		;; offset zero
;; B
@@GetFont_loop:
		push	dx
		lodsw
		mov	dx,ax
		lodsw
		;; ax = min , dx = low
		cmp	bx,dx
		jb	@@GetFont_ng
		cmp	bx,ax
		ja	@@GetFont_ng
		pop	dx
		sub	bx,ax
		add	dx,bx
		jmp	@@GetFont_getofs
@@GetFont_ng:
		sub	dx,ax
		inc	dx
		mov	ax,dx
		pop	dx
		add	dx,ax		;; add ofs
		loop	@@GetFont_loop
		stc			;; err !!!!
		jmp	@@GetFont_exit
@@GetFont_getofs:
		mov	ax,dx
		mov	bx,32
		mul	bx		;; ax * 32 = dx:ax
		add	ax,@@fontofs	;; font start offset
		adc	dx,0		;;
		;; dx:ax is ofs
		add	dx,KFONT_SEG_UPPER	;; 000ah
		mov	cx,ax		;; calc seg
		shr	cx,4		;;
		mov	dh,dl		;; dx << 8
		shl	dh,4		;; dx shl 12
		mov	dl,0		;; clear low
		or	dx,cx		;; dx is seg
		and	ax,000fh		;; ax is ofs
		mov	cx,1010h		;; ch = x, cl = y
		clc
		jmp	@@GetFont_exit

@@GetFont_ank:
		shl	ax,4			;; *16 ( 8dot * 16 dot font )
		mov	dx,AFONT_SEG
		mov	cx,0810h		;; ch = x, cl = y
		clc
@@GetFont_exit:

		pop	ds
		pop	si
		pop	bx

		ret

GetFont		endp

DrawPutKanji	proc C near
		local @@pac:PutImage_PACS,@@param:DWORD
		
		push	cx
		push	ds
		
		mov	ax,DATA
		mov	ds,ax
		;; backup param
		mov	word ptr @@param,bx
		mov	word ptr @@param.2,es
		;; copy parameter
		mov	ax,es:PutKnj_x[bx]
		mov	@@pac.PutImg_x,ax
		mov	ax,es:PutKnj_y[bx]
		mov	@@pac.PutImg_y,ax
		mov	ax,es:PutKnj_mode[bx]
		mov	@@pac.PutImg_mode,ax

		mov	ax,es:PutKnj_code[bx]
		call	GetFont
		jc	@@DrawPutKanji_ERROR	;; CODE ERROR
		mov	@@pac.PutImg_ofs,ax
		mov	@@pac.PutImg_seg,dx
		mov	al,ch
		cbw
		mov	@@pac.PutImg_width,ax
		mov	al,cl
		cbw
		mov	@@pac.PutImg_height,ax
		call	DrawPutImage

@@DrawPutKanji_ERROR:

		pop	ds
		pop	cx
		
		ret

DrawPutKanji	endp


; ---------------------------------------------------------------------------
; C[WGET
; NbvWl܂BNbvWÔƂ́AG[Ԃ܂B
; G[̂Ƃ̓C[W擾܂B
;
;  ES:BX    󂯓np\̂̃AhX
;
;  Ԃl
;           AX = 0  
;           AX = -1 si͈͊Oj
;
;@C[W͍l߂̂̂n܂iPutImageŎg`j
; ---------------------------------------------------------------------------
DrawGetImage	proc C	near
		local @@sx,@@ex,@@sy,@@ey,@@transsiz:word
		local @@DispWidth,@@DispHeight,@@PictWidth:word
		local @@writemask:byte,@@skiptop:byte
		local @@src:dword,@@dest:dword

		push	si
		push	di
		push	ds
		push	es

		push	DATA
		pop	ds				;; ZOg킹B

		mov	ax,es:GetImg_ofs[bx]
		mov	word ptr @@dest,ax
		mov	ax,es:GetImg_seg[bx]
		mov	word ptr @@dest.2,ax
;; w
		mov	ax,es:GetImg_x[bx]
		mov	@@sx,ax
		cmp	ax,DRAW_CLIP_SX
		jb	@@GetImg_Error
		mov	dx,es:GetImg_Width[bx]
		or	dx,dx
		jz	@@GetImg_Error
		cmp	dx,VRAMXSIZE * 8
		ja	@@GetImg_Error			;; C[WVRAM ?
		add	ax,dx
		dec	ax
		cmp	ax,DRAW_CLIP_EX				;; NbvWwH
		ja	@@GetImg_Error
		mov	@@ex,ax
		mov	@@DispWidth,dx			;; `sNZ
		dec	dx
		shr	dx,3
		inc	dx
		mov	@@PictWidth,dx			;; `oCg
;; x
		mov	ax,es:GetImg_y[bx]
		mov	@@sy,ax
		cmp	ax,DRAW_CLIP_SY
		jb	@@GetImg_Error
		mov	dx,es:GetImg_Height[bx]
		or	dx,dx				;; C[W not 0 ?
		jz	@@GetImg_Error
		cmp	dx,VRAMYSIZE
		ja	@@GetImg_Error			;; VRAMTCY傫H
		mov	@@DispHeight,dx
		add	ax,dx
		dec	ax
		cmp	ax,DRAW_CLIP_EY
		ja	@@GetImg_error			;; xnjH
		mov	@@ey,ax
;; 
		jmp	short @@GetImg_OK
;;
;; Wve[u
@@GetImg_Error:
		mov	ax,-1
		jmp	@@GetImg_Exit
@@GetImg_OK:
;;
;; gp̈̃NA
		mov	ax,@@DispHeight
		mov	dx,@@PictWidth
		mul	dx		;; byte *  = gp̈
		mov	cx,ax
		xor	al,al		;; ߂f[^NA
		les	di,@@dest	;; NAAhX
		cld
		repe	stosb		;; 0NA
;;
;; ]̐ݒ
		mov	dx,VIDEO_SEG		;;  vga vram segment.
		xor	ax,ax
		mov	word ptr @@src,ax
		mov	word ptr @@src.2,dx
;;
;; ]
		mov	ax,@@ex
		shr	ax,3
		mov	dx,@@sx
		shr	dx,3
		sub	ax,dx			;; 
		mov	@@transsiz,ax		;; ]
		mov	dx,@@DispWidth		;;
		dec	dx
		shr	dx,3			;; ݃oCg
		mov	@@skiptop,FALSE
		cmp	ax,dx
		jz	@@GetImg_normalop
		mov	@@skiptop,TRUE		;; ݕƃ\[X̓]ႤB
@@GetImg_normalop:
		mov	ax,@@DispWidth
		dec	ax
		and	ax,7
		mov	cx,7
		sub	cx,ax
		mov	al,1
		shl	al,cl
		dec	al
		not	al			;; I[}XN̐ݒ
		mov	@@writemask,al		;; !!!!!!! writepagep(mask)!!!!!
;;;;
		les	di,@@dest
		lds	si,@@src
		push	ax
		push	dx
		mov	ax,@@DispWidth		;; es:di̓Rs[̂Psڂ̖[B
		dec	ax
		shr	ax,3
		add	di,ax
		mov	ax,@@sy			;; I[̓]Ȃ̂ŁB
		mov	dx,VRAMXSIZE
		mul	dx
		add	si,ax
		mov	ax,@@ex
		shr	ax,3
		add	si,ax			;; DS:SI̓Rs[1sڂ̍s̖[B
		pop	dx
		pop	ax
@@GetImg_mainloop:		;; c[v
		push	di
		push	si
		mov	cx,@@sx
		and	cx,7
		mov	ah,1
		shl	ah,cl
		dec	ah			;; MSB [BH][AH] LSB
		mov	bh,ah
		not	bh
		mov	bl,byte ptr @@transsiz	;; ]f[^[h
		mov	dh,@@writemask		;; }XN[h
		std				;; Z !!!!!!!!!!!!!!!!!!
;; [̏
		lodsb				;; ރf[^[h
		rol	al,cl			;; VtgZ
		mov	dl,al
		and	al,dh			;; E}XNāA]NA
		cmp	@@skiptop,TRUE
		je	@@GetImg_looptrans
		stosb				;; 
		or	bl,bl			;; JE^[=0̂Ƃ͂łB
		jz	@@GetImg_endstate
@@GetImg_looptrans:
		lodsb				;; ރf[^[h
		rol	al,cl			;; VtgZ
		xchg	al,dl			;; Xchg AL <- f[^  DL <- f[^
		mov	dh,dl			;; DH <- f[^
		and	dh,bh			;; DH <- Vtgf[^NA
		and	al,ah			;; AL <- VtgȊÕf[^NA
		or	al,dh			;; 
		stosb				;; 
		dec	bl			;; byteݒ
		jne	@@GetImg_looptrans
@@GetImg_endstate:
		pop	si
		pop	di
		add	si,VRAMXSIZE
		add	di,@@PictWidth
		dec	@@DispHeight
		jnz	@@GetImg_Mainloop
		xor	ax,ax			;; IB
@@GetImg_Exit:
		pop	es
		pop	ds
		pop	di
		pop	si
		cld				;; ꉞdestination flagNA

		ret

DrawGetImage	endp

;
; rbg}XNp^[
;
BLOCKPATTERN	label	byte
		db	00000000b	; 0%
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b

		db	10000000b	; 10%
		db	00000000b
		db	00000000b
		db	00000000b
		db	00001000b
		db	00000000b
		db	00000000b
		db	00000000b

		db	10001000b	; 20%
		db	00000000b
		db	00000000b
		db	00000000b
		db	10001000b
		db	00000000b
		db	00000000b
		db	00000000b

		db	10001000b	; 30%
		db	00000000b
		db	00100010b
		db	00000000b
		db	10001000b
		db	00000000b
		db	00100010b
		db	00000000b

		db	10101010b	; 40%
		db	00000000b
		db	10101010b
		db	00000000b
		db	10101010b
		db	00000000b
		db	10101010b
		db	00000000b

HALFMASKPATTERN	label	byte		;; ꕔŒڎgB
		db	10101010b	; 50%
		db	01010101b
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010101b

		db	11111111b	; 60%
		db	01010101b
		db	11111111b
		db	01010101b
		db	11111111b
		db	01010101b
		db	11111111b
		db	01010101b

		db	11111111b	; 70%
		db	11011101b
		db	11111111b
		db	01110111b
		db	11111111b
		db	11011101b
		db	11111111b
		db	01110111b

		db	11111111b	; 80%
		db	11111111b
		db	11111111b
		db	01110111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	01110111b

		db	11111111b	; 90%
		db	11111111b
		db	11111111b
		db	11110111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	01111111b

		db	11111111b	; 100%
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b

IFE DRAWBIOS_DEBUG_ENABLE
BIOS		ENDS
ENDIF

		end
